﻿######################################################################################################################################################
# Script  : CreateLabStructure.ps1
# Author  : Ferry Stelte
# Purpose : Creates OU structure and users for a lab environment
# Version : 1.0
# Data    : 14-04-2015
######################################################################################################################################################
$BaseDN="DC=<Domain>,DC=<domain>"
$a = 1
$Password= convertto-securestring "P@ssW0rD!" -asplaintext -force
$LabOU="Lab"
$ChildOU1="East"
$ChildOU2="West"

New-ADOrganizationalUnit -Name:"$LabOU" -Path:$BaseDN -ProtectedFromAccidentalDeletion:$false
New-ADOrganizationalUnit -Name:"$ChildOU1" -Path:"OU=$LabOU,$BaseDN" -ProtectedFromAccidentalDeletion:$false
New-ADOrganizationalUnit -Name:"$ChildOU2" -Path:"OU=$LabOU,$BaseDN" -ProtectedFromAccidentalDeletion:$false

#Create All users and groups for ChildOU1
New-ADGroup -GroupCategory:"Security" -GroupScope:"Global" -Name:"$ChildOU1 Users" -Path:"OU=$ChildOU1,OU=$LabOU,$BaseDN" -SamAccountName:"$ChildOU1 Users"
DO

{
$Username= "$ChildOU1 user $a"
$SamAccountName=$ChildOU1+"user"+$a
$Surname="$ChildOU1$a"

New-ADUser -DisplayName:$Username -GivenName:"$LabOU" -Name:$Username -Path:"OU=$ChildOU1,OU=$LabOU,$BaseDN" -SamAccountName:$SamAccountName -Surname:$Surname -Type:"user" -UserPrincipalName:"$SamAccountName@stelte.local"
Set-ADAccountPassword -Identity:"CN=$Username,OU=$ChildOU1,OU=$LabOU,$BaseDN" -NewPassword:$Password -Reset:$true
Enable-ADAccount -Identity:"CN=$Username,OU=$ChildOU1,OU=$LabOU,$BaseDN"
Set-ADAccountControl -AccountNotDelegated:$false -AllowReversiblePasswordEncryption:$false -CannotChangePassword:$true -DoesNotRequirePreAuth:$false -Identity:"CN=$Username,OU=$ChildOU1,OU=$LabOU,$BaseDN" -PasswordNeverExpires:$true -UseDESKeyOnly:$false
Add-ADPrincipalGroupMembership -Identity:"CN=$username,OU=$ChildOU1,OU=$LabOU,$BaseDN" -MemberOf:"CN=$ChildOU1 Users,OU=$ChildOU1,OU=$LabOU,$BaseDN"
 $a++

} While ($a -le 10)


$a=1

#Create All users and groups for ChildOU2
New-ADGroup -GroupCategory:"Security" -GroupScope:"Global" -Name:"$ChildOU2 Users" -Path:"OU=$ChildOU2,OU=$LabOU,$BaseDN" -SamAccountName:"$ChildOU2 Users"
DO

{
$Username= "$ChildOU2 user $a"
$SamAccountName=$ChildOU2+"user"+$a
$Surname="$ChildOU2$a"

New-ADUser -DisplayName:$Username -GivenName:$LabOU -Name:$Username -Path:"OU=$ChildOU2,OU=$LabOU,$BaseDN" -SamAccountName:$SamAccountName -Surname:$Surname -Type:"user" -UserPrincipalName:"$SamAccountName@stelte.local"
Set-ADAccountPassword -Identity:"CN=$Username,OU=$ChildOU2,OU=$LabOU,$BaseDN" -NewPassword:$Password -Reset:$true
Enable-ADAccount -Identity:"CN=$Username,OU=$ChildOU2,OU=$LabOU,$BaseDN"
Set-ADAccountControl -AccountNotDelegated:$false -AllowReversiblePasswordEncryption:$false -CannotChangePassword:$true -DoesNotRequirePreAuth:$false -Identity:"CN=$Username,OU=$ChildOU2,OU=$LabOU,$BaseDN" -PasswordNeverExpires:$true -UseDESKeyOnly:$false
Add-ADPrincipalGroupMembership -Identity:"CN=$username,OU=$ChildOU2,OU=$LabOU,$BaseDN" -MemberOf:"CN=$ChildOU2 Users,OU=$ChildOU2,OU=$LabOU,$BaseDN"
 $a++

} While ($a -le 10)